/*
 * Copyright 1995 Vectaport Inc., Cider Press
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the names of the copyright holders not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  The copyright holders make
 * no representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 */

#ifndef vpfscripts_h
#define vpfscripts_h

#include <MapUnidraw/mapscripts.h>

class VpfFClassComp;
class VpfCovComp;
class VpfDbComp;
class VpfIdrawComp;
class VpfLibComp;

class VpfFClassScript : public MapFClassScript {
public:
    virtual ClassId GetClassId();
    virtual boolean IsA(ClassId);
    VpfFClassScript(VpfFClassComp* = nil);
    virtual boolean Definition(ostream&);

    static int ReadName(istream& in, void* addr1, void* addr2, void* addr3, void* addr4);
};

class VpfCovScript : public MapCovScript {
public:
    virtual ClassId GetClassId();
    virtual boolean IsA(ClassId);
    VpfCovScript(VpfCovComp* = nil);

    static int ReadName(istream& in, void* addr1, void* addr2, void* addr3, void* addr4);
    static int ReadChildren(istream&, void*, void*, void*, void*);
};

class VpfLibScript : public MapLibScript {
public:
    virtual ClassId GetClassId();
    virtual boolean IsA(ClassId);
    VpfLibScript(VpfLibComp* = nil);

    static int ReadName(istream& in, void* addr1, void* addr2, void* addr3, void* addr4);
    static int ReadChildren(istream&, void*, void*, void*, void*);
};

class VpfDbScript : public MapDbScript {
public:
    virtual ClassId GetClassId();
    virtual boolean IsA(ClassId);
    VpfDbScript(VpfDbComp* = nil);

    static int ReadPath(istream& in, void* addr1, void* addr2, void* addr3, void* addr4);
    static int ReadChildren(istream&, void*, void*, void*, void*);
};

class VpfIdrawScript : public MapIdrawScript {
public:
    virtual ClassId GetClassId();
    virtual boolean IsA(ClassId);
    VpfIdrawScript(VpfIdrawComp* = nil);

    virtual boolean Emit(ostream&);
    static int ReadChildren(istream&, void*, void*, void*, void*);
    static int ReadProjection(istream&, void*, void*, void*, void*);
};

class VpfFClassRawScript : public MapFClassScript {
public:
    virtual ClassId GetClassId();
    virtual boolean IsA(ClassId);
    VpfFClassRawScript(VpfFClassComp* = nil);

    virtual boolean Definition(ostream&);
    virtual void Update();
  void TileId(int i) { _tileid = i; }

protected:
    OverlayScript* CreateRawMapScript(OverlayComp*);
    int _tileid;

};

#endif
